From: Junio C Hamano <gitster@pobox.com>
To: git@vger.kernel.org
Subject: [PATCH] test-lib: catch misspelt 'test_expect_successo'
Date: Tue, 24 Mar 2026 11:13:26 -0700 [thread overview]
Message-ID: <xmqqmrzxyu2h.fsf_-_@gitster.g> (raw)
In-Reply-To: <xmqqcy0t178a.fsf_-_@gitster.g> (Junio C. Hamano's message of "Tue, 24 Mar 2026 10:13:09 -0700")
In order to catch mistakes like misspelling "test_expect_success",
we would like to eventually be able to run our test suite with the
"-e" option on.
All tests dot-source "test-lib.sh" as the first thing to do.
Starting the script with "set -e" immediately reveals one place in
the test framework itself that is not clean.
The test framework runs "$GIT_BINARY" without any argument. We
expect it to exit with status 1 (i.e., "git<RETURN>" that spits out
the list of common commands) as a sign that we have an instance of
Git that we want to test. We cannot quite say
git
if test $? != 1; then you have not built git; fi
as the first invocation that exits non-zero is caught with "set -e".
Work this around by rewriting the construct like so:
status=0; git || status=$?
if test $status != 1; then you have not built git; fi
Signed-off-by: Junio C Hamano <gitster@pobox.com>
---
* As we look into other breakages, we may discover more breakages
in the test framework that need to be fixed, but this change
alone seems to get thing going for many test scripts.
t/test-lib.sh | 7 +++++--
1 file changed, 5 insertions(+), 2 deletions(-)
diff --git i/t/test-lib.sh w/t/test-lib.sh
index 70fd3e9baf..a2aa97fba3 100644
--- i/t/test-lib.sh
+++ w/t/test-lib.sh
@@ -17,6 +17,9 @@
# Test the binaries we have just built. The tests are kept in
# t/ subdirectory and are run in 'trash directory' subdirectory.
+
+set -e
+
if test -z "$TEST_DIRECTORY"
then
# ensure that TEST_DIRECTORY is an absolute path so that it
@@ -143,8 +146,8 @@ export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
################################################################
# It appears that people try to run tests without building...
GIT_BINARY="${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X"
-"$GIT_BINARY" >/dev/null
-if test $? != 1
+status=0 && "$GIT_BINARY" >/dev/null || status=$?
+if test $status != 1
then
if test -n "$GIT_TEST_INSTALLED"
then
next prev parent reply other threads:[~2026-03-24 18:13 UTC|newest]
Thread overview: 16+ messages / expand[flat|nested] mbox.gz Atom feed top
2026-03-24 14:52 [PATCH] t4014: fix call to `test_expect_success ()` Patrick Steinhardt
2026-03-24 15:18 ` Mirko Faina
2026-03-24 15:38 ` Junio C Hamano
2026-03-24 15:48 ` Mirko Faina
2026-03-24 16:39 ` Junio C Hamano
2026-03-24 17:13 ` Re* " Junio C Hamano
2026-03-24 18:05 ` [PATCH] t6002: make test "set -e" clean Junio C Hamano
2026-03-24 18:13 ` Junio C Hamano [this message]
2026-03-24 19:35 ` [PATCH] test-lib: catch misspelt 'test_expect_successo' Jeff King
2026-03-24 19:48 ` Junio C Hamano
2026-03-25 5:46 ` Jeff King
2026-03-24 18:20 ` [PATCH] t0008: make test "set -e" clean Junio C Hamano
2026-03-24 18:32 ` [PATCH] t7450: " Junio C Hamano
2026-03-24 18:38 ` Eric Sunshine
2026-03-24 19:03 ` Junio C Hamano
2026-03-25 7:07 ` Re* [PATCH] t4014: fix call to `test_expect_success ()` Patrick Steinhardt
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=xmqqmrzxyu2h.fsf_-_@gitster.g \
--to=gitster@pobox.com \
--cc=git@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox